package gui;

import java.awt.Dimension;
import java.awt.EventQueue;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.math.BigInteger;
import java.security.InvalidAlgorithmParameterException;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;
import java.security.interfaces.ECPrivateKey;
import java.security.interfaces.ECPublicKey;
import java.security.spec.ECField;
import java.security.spec.ECFieldFp;
import java.security.spec.ECParameterSpec;
import java.security.spec.ECPoint;
import java.security.spec.EllipticCurve;
import java.util.Random;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTextArea;

import rns.ECC;
import rns.Hardware;
import rns.Main;
import rns.RNSChannel;
import rns.RSA;
import rns.Rns;

import javax.swing.JTextField;
import javax.swing.JRadioButton;
import javax.swing.JCheckBox;
import javax.swing.AbstractAction;
import javax.swing.Action;
import javax.swing.JTabbedPane;

import java.awt.GridLayout;
import java.awt.SystemColor;
import java.awt.Color;



public class MainWindow {

	private JFrame frame;
	private JTextArea[][] textArea;
	private boolean printing;
	private boolean goToEnd;
	public static MainWindow windowBase;
	private Thread tr;
	private JTextField textField;
	private JTextField textField_1;
	private JTextField textField_2;
	static private JTextField textField_3;
	private JTextField textField_4;
	private final Action action = new SwingAction();
	JRadioButton rdbtnRandom = new JRadioButton("Random");
	private JTextField textField_5;
	private JButton btnNewButton;
	private JButton btnNext ;
	private JButton btnEnd;
	private JPanel panel;
	JScrollPane scrollPane;
	JScrollPane scrollPane_1;
//	private JTabbedPane tabbedPane;
	private JPanel panel_1;
	private JTabbedPane tabbedPane_1;
	private JPanel panel_2;
	private JTextField textField_6;
	private JTextField textField_7;
	private final Action action_1 = new SwingAction_1();
	private JTextField textField_8;
	private JTextField textField_9;
	private JTextField textField_10;
	private JTextField textField_11;
	private JTextField textField_12;
	JRadioButton rdbtnExample;
	private JTextField textField_13;
	private JTextField textField_14;
	JButton button ;
	JButton endBtnECC;
	JButton nextBtnECC;
	JPanel panel_3;
	private JTextField textField_15;
	private JLabel lblModuloN;
	
	int last_modulus,last_base;

	/**
	 * Launch the application.
	 */
	public static void main(String[] args) {
		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {

					windowBase = new MainWindow("RNS");
					windowBase.frame.setVisible(true);
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

	/**
	 * Create the application.
	 */
	public MainWindow(String name) {
		initialize(name);
		frame.setVisible(true);
		printing = false;
		goToEnd = false;

	}

	/**
	 * Initialize the contents of the frame.
	 */
	private void initialize(String name) {
		frame = new JFrame(name);
		frame.setBounds(100, 100, 499, 630);
		frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		frame.getContentPane().setLayout(new GridLayout(0, 1, 0, 0));
		
		tabbedPane_1 = new JTabbedPane(JTabbedPane.TOP);
		frame.getContentPane().add(tabbedPane_1);
		
		panel_1 = new JPanel();
		tabbedPane_1.addTab("RSA", null, panel_1, null);
		panel_1.setLayout(null);
		
		panel = new JPanel();
		panel.setLayout(null);
		panel.setPreferredSize(new Dimension(30+((Main.MODULI_NO-1)*78)+68, 260));
		scrollPane = new JScrollPane();
		scrollPane.setBounds(80, 189, 393, 292);
		scrollPane.setColumnHeaderView(panel);
		panel_1.add(scrollPane);
		
				
				
				
				
				
				JLabel lblBase = new JLabel("Base 1");
				lblBase.setBounds(35, 231, 46, 14);
				panel_1.add(lblBase);
				
				JLabel lblBase_1 = new JLabel("Base 2");
				lblBase_1.setBounds(34, 321, 46, 14);
				panel_1.add(lblBase_1);
				
//				JLabel lblRedundan = new JLabel("Redundant");
//				lblRedundan.setBounds(10, 425, 71, 14);
//				panel_1.add(lblRedundan);
				
				btnNext = new JButton("Next");
				btnNext.setEnabled(false);
				btnNext.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						if(tr!=null){
							synchronized(tr){
								tr.notify();
							}
						}
					}
				});
				btnNext.setBounds(384, 492, 89, 23);
				panel_1.add(btnNext);
				
				btnEnd = new JButton("End");
				btnEnd.setEnabled(false);
				btnEnd.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						goToEnd = true;
						btnNext.setEnabled(false);
						btnEnd.setEnabled(false);
						if(tr!=null){
							synchronized(tr){
								tr.notify();
							}
						}
					}
				});
				btnEnd.setBounds(285, 492, 89, 23);
				panel_1.add(btnEnd);
				
				textField = new JTextField();
				textField.setBounds(80, 11, 393, 20);
				panel_1.add(textField);
				textField.setColumns(10);
				
				JLabel lblMsg = new JLabel("Msg");
				lblMsg.setBounds(24, 14, 46, 14);
				panel_1.add(lblMsg);
				
				textField_1 = new JTextField();
				textField_1.setColumns(10);
				textField_1.setBounds(80, 42, 393, 20);
				panel_1.add(textField_1);
				
				JLabel lblKey = new JLabel("Key");
				lblKey.setBounds(24, 45, 46, 14);
				panel_1.add(lblKey);
				
				textField_2 = new JTextField();
				textField_2.setColumns(10);
				textField_2.setBounds(80, 72, 393, 20);
				panel_1.add(textField_2);
				
				JLabel lblModulo = new JLabel("Modulo");
				lblModulo.setBounds(24, 75, 46, 14);
				panel_1.add(lblModulo);
				
				JLabel lblResult = new JLabel("Result");
				lblResult.setBounds(24, 529, 46, 14);
				panel_1.add(lblResult);
				
				textField_3 = new JTextField();
				textField_3.setEditable(false);
				textField_3.setColumns(10);
				textField_3.setBounds(80, 526, 393, 20);
				panel_1.add(textField_3);
				
				btnNewButton = new JButton("Start");
				btnNewButton.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						Main.KEY_SIZE = Integer.parseInt(textField_4.getText());
						Main.BITS_PER_MOD = Integer.parseInt(textField_5.getText()); 
						Main.MODULI_NO = (int)(Math.ceil(Main.KEY_SIZE/(double)Main.BITS_PER_MOD))+1;
						System.out.println("Number of moduli: "+Main.MODULI_NO);
						if(rdbtnRandom.isSelected()){
							Random generator = new Random();
							BigInteger[] keys;
							BigInteger Msg = new BigInteger(Main.KEY_SIZE,generator);
							keys=RSA.generateKeys(Main.KEY_SIZE);
							RSA.publickey=keys[2];
							RSA.key=keys[1];
							RSA.N = keys[0];
							RSA.MSG = Msg.mod(RSA.N);
							textField.setText(Msg.toString());
							textField_1.setText(keys[1].toString());
							textField_2.setText(keys[0].toString());
							
						}else{
							RSA.key= new BigInteger(textField_1.getText());
							RSA.N = new BigInteger(textField_2.getText());
							RSA.MSG = new BigInteger(textField.getText());
						}
						last_modulus=-1;
						last_base=-1;
						setPriting(false);
						btnNewButton.setEnabled(false);
						btnNext.setEnabled(true);
						btnEnd.setEnabled(true);
						rdbtnRandom.setEnabled(false);
						textField_4.setEditable(!textField_4.isEditable());
						textField_5.setEditable(!textField_5.isEditable());
						textField_3.setText("");
						
						textArea = new JTextArea[2][Main.MODULI_NO];
						/*first base*/
						for(int i=0; i < Main.MODULI_NO; i++){
							textArea[0][i] = new JTextArea();
							textArea[0][i].setBounds(10+(i*78), 11, 68, 76);
							textArea[0][i].setRows(4);
							textArea[0][i].setEditable(false);
							textArea[0][i].setColumns(8);
							panel.add(textArea[0][i]);
						}
						/*second base*/
						for(int i=0; i < Main.MODULI_NO; i++){
							textArea[1][i] = new JTextArea();
							textArea[1][i].setBounds(10+(i*78), 102, 68, 76);
							textArea[1][i].setRows(4);
							textArea[1][i].setEditable(false);
							textArea[1][i].setColumns(8);
							panel.add(textArea[1][i]);
						}
						
//						textArea[0][0] = new JTextArea();
//						textArea[0][0].setBounds(10, 193, 68, 76);
//						textArea[0][0].setRows(4);
//						textArea[0][0].setEditable(false);
//						textArea[0][0].setColumns(8);
//						panel.add(textArea[0][0]);
						
						panel.setPreferredSize(new Dimension(30+((Main.MODULI_NO-1)*78)+68, 260));
						scrollPane.setViewportView(panel);
						new Thread(new RSA()).start();
					}
				});
				btnNewButton.setBounds(196, 131, 104, 47);
				panel_1.add(btnNewButton);
				
				textField_4 = new JTextField();
				textField_4.setBounds(106, 100, 46, 20);
				panel_1.add(textField_4);
				textField_4.setColumns(10);
				
				JLabel lblBits = new JLabel("Bits");
				lblBits.setBounds(162, 103, 46, 14);
				panel_1.add(lblBits);
				
				rdbtnRandom = new JRadioButton("Random");
				rdbtnRandom.setAction(action);
				rdbtnRandom.setBounds(20, 99, 85, 23);
				panel_1.add(rdbtnRandom);
				
				textField_5 = new JTextField();
				textField_5.setBounds(387, 100, 86, 20);
				panel_1.add(textField_5);
				textField_5.setColumns(10);
				
				JLabel lblNumberOfBits = new JLabel("Number of bits per channel");
				lblNumberOfBits.setBounds(223, 103, 157, 14);
				panel_1.add(lblNumberOfBits);
				
				panel_2 = new JPanel();
				tabbedPane_1.addTab("ECC", null, panel_2, null);
				panel_2.setLayout(null);
				
				scrollPane_1 = new JScrollPane();
				scrollPane_1.setBounds(80, 189, 393, 292);
				
				panel_3 = new JPanel();
				panel_3.setLayout(null);
				panel.setPreferredSize(new Dimension(30+((Main.MODULI_NO-1)*78)+68, 260));
				scrollPane_1.setColumnHeaderView(panel_3);
				
				panel_2.add(scrollPane_1);
				
//				JLabel label = new JLabel("Redundant");
//				label.setBounds(10, 425, 71, 14);
//				panel_2.add(label);
				
				JLabel label_1 = new JLabel("Base 2");
				label_1.setBounds(34, 321, 46, 14);
				panel_2.add(label_1);
				
				JLabel label_2 = new JLabel("Base 1");
				label_2.setBounds(35, 231, 46, 14);
				panel_2.add(label_2);
				
				button = new JButton("Start");
				button.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {

						
						if(rdbtnExample.isSelected()){
							Main.KEY_SIZE = 256;//32;
							//Main.BITS_PER_MOD = 16;
							Main.BITS_PER_MOD = Integer.parseInt(textField_7.getText()); 
							Main.MODULI_NO = (int) Math.ceil(Main.KEY_SIZE/(float)Main.BITS_PER_MOD)+1;
							ECC.scalar = new BigInteger("4");//new BigInteger("4");                                             //new BigInteger("a78a236d60baec0c5dd41b33a542463a8255391af64c74ee",16);//new BigInteger("4");//new BigInteger("4");
							ECC.a =      new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFC",16);///new BigInteger("fffffffffffffffffffffffffffffffefffffffffffffffc",16);//new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFC",16);// new BigInteger("25"); 
							ECC.b =      new BigInteger("5AC635D8AA3A93E7B3EBBD55769886BC651D06B0CC53B0F63BCE3C3E27D2604B",16);///new BigInteger("64210519e59c80e70fa7e9ab72243049feb8deecc146b9b1",16);//new BigInteger("5AC635D8AA3A93E7B3EBBD55769886BC651D06B0CC53B0F63BCE3C3E27D2604B",16);//new BigInteger("37");
							ECC.x =      new BigInteger("6b17d1f2e12c4247f8bce6e563a440f277037d812deb33a0f4a13945d898c296",16);///new BigInteger("d458e7d127ae671b0c330266d246769353a012073e97acf8",16);//new BigInteger("6b17d1f2e12c4247f8bce6e563a440f277037d812deb33a0f4a13945d898c296",16);//new BigInteger("3");
							ECC.y =      new BigInteger("4fe342e2fe1a7f9b8ee7eb4a7c0f9e162bce33576b315ececbb6406837bf51f5",16);///new BigInteger("325930500d851f336bddc050cf7fb11b5673a1645086df3b",16);//new BigInteger("4fe342e2fe1a7f9b8ee7eb4a7c0f9e162bce33576b315ececbb6406837bf51f5",16);//new BigInteger("65");
							ECC.N =      new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFF", 16);//new BigInteger("fffffffffffffffffffffffffffffffeffffffffffffffff",16);//new BigInteger("FFFFFFFF00000001000000000000000000000000FFFFFFFFFFFFFFFFFFFFFFFF", 16);//new BigInteger("227");
							Main.KEY_SIZE = 256;
							//Main.BITS_PER_MOD = 16;
							Main.MODULI_NO = (int) Math.ceil(Main.KEY_SIZE/(float)Main.BITS_PER_MOD)+1;
							
							try {
								ECField field = new ECFieldFp( ECC.N );
								EllipticCurve curve = new EllipticCurve(
										field, 
										ECC.a, 
										ECC.b);
								ECPoint g = new ECPoint(
										ECC.x, 
										ECC.y);
								ECParameterSpec ECCspecs = new ECParameterSpec(
										curve, 
										g, 
										new BigInteger("FFFFFFFF00000000FFFFFFFFFFFFFFFFBCE6FAADA7179E84F3B9CAC2FC632551",16), 
										1);
							
								KeyPairGenerator generator = KeyPairGenerator.getInstance("EC");
								generator.initialize(ECCspecs, new SecureRandom());
								KeyPair pair = generator.generateKeyPair();
								ECPrivateKey priv =(ECPrivateKey) pair.getPrivate();
								ECPublicKey pub = (ECPublicKey) pair.getPublic();
								
								ECC.scalar = priv.getS();
								
								System.out.println("Base Point: " );
								System.out.println("  x coord: "+ g.getAffineX() );
								System.out.println("  y coord: "+ g.getAffineY() );
								System.out.println("Private Key: "+ECC.scalar);
								System.out.println("Public Key (expected result): " + pub.toString());
							
							} catch (NoSuchAlgorithmException f) {
								// TODO Auto-generated catch block
								f.printStackTrace();
							} catch (InvalidAlgorithmParameterException f) {
								// TODO Auto-generated catch block
								f.printStackTrace();
							}
							
							
							
							
							
							
							
							
							
							
							textField_6.setText(String.valueOf(Main.KEY_SIZE));
							//textField_7.setText(String.valueOf(Main.BITS_PER_MOD));
							textField_12.setText(String.valueOf(ECC.scalar));
							textField_8.setText(String.valueOf(ECC.a));
							textField_9.setText(String.valueOf(ECC.b));
							textField_10.setText(String.valueOf(ECC.x));
							textField_11.setText(String.valueOf(ECC.y));
							textField_15.setText(String.valueOf(ECC.N));
						}else{
							Main.KEY_SIZE = Integer.parseInt(textField_6.getText());
							Main.BITS_PER_MOD = Integer.parseInt(textField_7.getText()); 
							Main.MODULI_NO = (int) Math.ceil(Main.KEY_SIZE/(float)Main.BITS_PER_MOD)+1;
							ECC.scalar = new BigInteger(textField_12.getText());
							ECC.a = new BigInteger(textField_8.getText());
							ECC.b = new BigInteger(textField_9.getText());
							ECC.x = new BigInteger(textField_10.getText());
							ECC.y = new BigInteger(textField_11.getText());
							ECC.N = new BigInteger(textField_15.getText());
							textField_12.setEditable(false);
							textField_15.setEditable(false);
							textField_6.setEditable(false);
							textField_7.setEditable(false);
							textField_8.setEditable(false);
							textField_9.setEditable(false);
							textField_10.setEditable(false);
							textField_11.setEditable(false);
						}
						last_modulus=-1;
						last_base=-1;
						setPriting(false);
						button.setEnabled(false);
						endBtnECC.setEnabled(true);
						nextBtnECC.setEnabled(true);
						rdbtnExample.setEnabled(false);
						textField_3.setText("");

						
						
						
						textArea = new JTextArea[2][Main.MODULI_NO];
						/*first base*/
						for(int i=0; i < Main.MODULI_NO; i++){
							textArea[0][i] = new JTextArea();
							textArea[0][i].setBounds(10+(i*78), 11, 68, 76);
							textArea[0][i].setRows(4);
							textArea[0][i].setEditable(false);
							textArea[0][i].setColumns(8);
							panel_3.add(textArea[0][i]);
						}
						/*second base*/
						for(int i=0; i < Main.MODULI_NO; i++){
							textArea[1][i] = new JTextArea();
							textArea[1][i].setBounds(10+(i*78), 102, 68, 76);
							textArea[1][i].setRows(4);
							textArea[1][i].setEditable(false);
							textArea[1][i].setColumns(8);
							panel_3.add(textArea[1][i]);
						}
						
//						textArea[0][0] = new JTextArea();
//						textArea[0][0].setBounds(10, 193, 68, 76);
//						textArea[0][0].setRows(4);
//						textArea[0][0].setEditable(false);
//						textArea[0][0].setColumns(8);
//						panel_3.add(textArea[0][0]);
						
						panel_3.setPreferredSize(new Dimension(30+((Main.MODULI_NO-1)*78)+68, 260));
						scrollPane_1.setViewportView(panel_3);
						new Thread(new ECC()).start();
						
					}
				});
				button.setBounds(196, 131, 104, 47);
				panel_2.add(button);
				
				endBtnECC = new JButton("End");
				endBtnECC.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent arg0) {
						goToEnd = true;
						endBtnECC.setEnabled(false);
						nextBtnECC.setEnabled(false);
						if(tr!=null){
							synchronized(tr){
								tr.notify();
							}
						}
					}
				});
				endBtnECC.setEnabled(false);
				endBtnECC.setBounds(285, 492, 89, 23);
				panel_2.add(endBtnECC);
				
				nextBtnECC = new JButton("Next");
				nextBtnECC.addActionListener(new ActionListener() {
					public void actionPerformed(ActionEvent e) {
						if(tr!=null){
							synchronized(tr){
								tr.notify();
							}
						}
					}
				});
				nextBtnECC.setEnabled(false);
				nextBtnECC.setBounds(384, 492, 89, 23);
				panel_2.add(nextBtnECC);
				
				JLabel label_3 = new JLabel("Bits");
				label_3.setBounds(12, 104, 46, 14);
				panel_2.add(label_3);
				
				rdbtnExample = new JRadioButton("Example");
				rdbtnExample.setAction(action_1);
				rdbtnExample.setBounds(58, 70, 85, 23);
				panel_2.add(rdbtnExample);
				
				textField_6 = new JTextField();
				textField_6.setColumns(10);
				textField_6.setBounds(10, 117, 46, 20);
				panel_2.add(textField_6);
				
				JLabel label_4 = new JLabel("Number of bits per channel");
				label_4.setBounds(10, 139, 157, 14);
				panel_2.add(label_4);
				
				textField_7 = new JTextField();
				textField_7.setColumns(10);
				textField_7.setBounds(9, 152, 86, 20);
				panel_2.add(textField_7);
				
				JLabel lblNewLabel = new JLabel("Curve 'a'");
				lblNewLabel.setBounds(20, 14, 71, 14);
				panel_2.add(lblNewLabel);
				
				textField_8 = new JTextField();
				textField_8.setColumns(10);
				textField_8.setBounds(80, 11, 46, 20);
				panel_2.add(textField_8);
				
				JLabel lblParameterb = new JLabel("Curve 'b'");
				lblParameterb.setBounds(20, 42, 71, 14);
				panel_2.add(lblParameterb);
				
				textField_9 = new JTextField();
				textField_9.setColumns(10);
				textField_9.setBounds(80, 39, 46, 20);
				panel_2.add(textField_9);
				
				JLabel lblEcxCoordinate = new JLabel("Point 'x' coordinate");
				lblEcxCoordinate.setBounds(138, 14, 117, 14);
				panel_2.add(lblEcxCoordinate);
				
				textField_10 = new JTextField();
				textField_10.setColumns(10);
				textField_10.setBounds(254, 11, 219, 20);
				panel_2.add(textField_10);
				
				JLabel lblEcyCoordinate = new JLabel("Point 'y' coordinate");
				lblEcyCoordinate.setBounds(138, 45, 117, 14);
				panel_2.add(lblEcyCoordinate);
				
				textField_11 = new JTextField();
				textField_11.setColumns(10);
				textField_11.setBounds(254, 42, 219, 20);
				panel_2.add(textField_11);
				
				textField_12 = new JTextField();
				textField_12.setColumns(10);
				textField_12.setBounds(254, 72, 219, 20);
				panel_2.add(textField_12);
				
				JLabel lblScalarToMultiplu = new JLabel("Scalar to multiply");
				lblScalarToMultiplu.setBounds(151, 75, 104, 14);
				panel_2.add(lblScalarToMultiplu);
				
				textField_13 = new JTextField();
				textField_13.setEditable(false);
				textField_13.setColumns(10);
				textField_13.setBounds(254, 532, 219, 20);
				panel_2.add(textField_13);
				
				textField_14 = new JTextField();
				textField_14.setEditable(false);
				textField_14.setColumns(10);
				textField_14.setBounds(10, 532, 219, 20);
				panel_2.add(textField_14);
				
				JLabel lblResultXCoordinate = new JLabel("Result 'x' coordinate:");
				lblResultXCoordinate.setBounds(10, 515, 157, 14);
				panel_2.add(lblResultXCoordinate);
				
				JLabel lblY = new JLabel("'y' coordinate");
				lblY.setBounds(254, 515, 104, 14);
				panel_2.add(lblY);
				
				textField_15 = new JTextField();
				textField_15.setColumns(10);
				textField_15.setBounds(254, 100, 219, 20);
				panel_2.add(textField_15);
				
				lblModuloN = new JLabel("GF(p)");
				lblModuloN.setBounds(215, 103, 40, 14);
				panel_2.add(lblModuloN);
		
		
		
		

		
		
	}
	
	public void print(String text,int modulus, int base){
		if(!goToEnd){
//			if(printing){
				textArea[base-1][modulus].setText(text);
				if(last_modulus!=-1 && last_base!=-1){
					textArea[last_base][last_modulus].setBackground(new Color(255, 255, 255));
				}
				textArea[base-1][modulus].setBackground(new Color(176, 196, 222));
				last_base=base-1;
				last_modulus=modulus;
				tr = Thread.currentThread();
				synchronized(tr){
					try {
						tr.wait();
					} catch (InterruptedException e) {
						e.printStackTrace();
					}
				}
//			}
		}
		
	}
	
	
	public boolean isPrinting() {
		return printing;
	}

	public void setPriting(boolean printing) {
		this.printing = printing;
	}
	private class SwingAction extends AbstractAction {
		public SwingAction() {
			putValue(NAME, "Random");
			putValue(SHORT_DESCRIPTION, "Set random values");
		}
		public void actionPerformed(ActionEvent e) {
			textField.setEditable(!textField.isEditable());
			textField_1.setEditable(!textField_1.isEditable());
			textField_2.setEditable(!textField_2.isEditable());
//			textField_4.setEditable(!textField_4.isEditable());
		}
	}
	
	public void setRestultRSA(BigInteger result){
		textField_3.setText(result.toString());
		btnNewButton.setEnabled(true);
		btnNext.setEnabled(false);
		btnEnd.setEnabled(false);
		textField_4.setEditable(!textField_4.isEditable());
		textField_5.setEditable(!textField_5.isEditable());
		rdbtnRandom.setEnabled(true);
		goToEnd=false;
		System.out.println("Registers after computation. Base1: "+Hardware.getNumberOfRegisters(1));
		System.out.println("Registers after computation. Base2: "+Hardware.getNumberOfRegisters(2));
		System.out.println("Registers after computation. Extra modulus: "+Hardware.getNumberOfRegisters(0));
		/*first base*/
		for(int i=0; i < Main.MODULI_NO; i++){
			panel.remove(textArea[0][i]);
		}
		/*second base*/
		for(int i=0; i < Main.MODULI_NO; i++){
			panel.remove(textArea[1][i]);
		}
		
//		panel.remove(textArea[0][0]);
		panel.repaint();
	}
	
	
	public void setRestultECC(BigInteger x,BigInteger y){
		textField_14.setText(x.toString());
		textField_13.setText(y.toString());
		button.setEnabled(true);
		endBtnECC.setEnabled(false);
		nextBtnECC.setEnabled(false);
		rdbtnExample.setEnabled(true);
		
		rdbtnExample.setSelected(false);
		textField_12.setEditable(true);
		textField_15.setEditable(true);
		textField_6.setEditable(true);
		textField_7.setEditable(true);
		textField_8.setEditable(true);
		textField_9.setEditable(true);
		textField_10.setEditable(true);
		textField_11.setEditable(true);
		
		goToEnd=false;
		System.out.println("Number of registers after computation. Base1: "+Hardware.getNumberOfRegisters(1));
		System.out.println("Number of registers after computation. Base2: "+Hardware.getNumberOfRegisters(2));
		System.out.println("Number of registers after computation. Extra modulus: "+Hardware.getNumberOfRegisters(0));
		/*first base*/
		for(int i=0; i < Main.MODULI_NO; i++){
			panel_3.remove(textArea[0][i]);
		}
		/*second base*/
		for(int i=0; i < Main.MODULI_NO; i++){
			panel_3.remove(textArea[1][i]);
		}
		
//		panel_3.remove(textArea[0][0]);
		panel_3.repaint();
	}
	private class SwingAction_1 extends AbstractAction {
		public SwingAction_1() {
			putValue(NAME, "Random");
			putValue(SHORT_DESCRIPTION, "Set example EC point, curve, and scalar");
		}
		public void actionPerformed(ActionEvent e) {
			textField_12.setEditable(!textField_12.isEditable());
			textField_15.setEditable(!textField_15.isEditable());
			textField_6.setEditable(!textField_6.isEditable());
			//textField_7.setEditable(!textField_7.isEditable());
			textField_7.setText(String.valueOf(Main.BITS_PER_MOD));
			textField_8.setEditable(!textField_8.isEditable());
			textField_9.setEditable(!textField_9.isEditable());
			textField_10.setEditable(!textField_10.isEditable());
			textField_11.setEditable(!textField_11.isEditable());
		}
	}
}
