package rns;

import gui.MainWindow;

import java.math.BigInteger;

/**
 * Class implementing the RNS Curve Point
 * @author Juvenal
 * 
 */
public class ECPointRNS {
	ECPoint_ binPoint;
//	BigInteger x_bin_OD;
//	BigInteger y_bin_OD;
	public static BigInteger a_bin_OD;
	public static BigInteger b_bin_OD;
	Rns x_MD;	/* in MD */
	Rns y_MD;	/* in MD */
	public static Rns N_Rns;
	public static BigInteger N;
	public static Rns a_MD;	/* in MD */
	public static Rns b_MD;	/* in MD */
	public static Rns a_OD;	/* in OD */
	public static Rns b_OD;	/* in OD */
	
	
	//static Rns MMmodN;
	//static Rns one;
	public static Rns eight;
	public static Rns four;
	//static Rns MmodN;
	public static Rns two;
	
	
	
	final boolean debug=false;
	
	/**
	 * Creates a new point
	 * @param x
	 * 			x coordinate
	 * @param y
	 * 			y coordinate
	 * @param useYcoordinate
	 * 			indicates whether the y coordinate is used and should be sent to the coprocessor
	 */
	public ECPointRNS(BigInteger x,BigInteger y,boolean useYcoordinate/*BigInteger N, BigInteger a, BigInteger b*/ ){
		
		
		binPoint = new ECPoint_(x, y, N, a_bin_OD, b_bin_OD);

		
		Main.codeFile.println("-- INIT");
		Main.dataFile.println("-- INIT: x coordinate");
		
		this.x_MD = new Rns(x.toString(),"x_MD");
		if(useYcoordinate)
			this.y_MD = new Rns(y.toString(),"y_MD"); //not used in point scalar multiplication
		
		x_MD.modularMult(Rns.MMmodN, x_MD); /* to MD */
		if(useYcoordinate)
			y_MD.modularMult(Rns.MMmodN, y_MD); /* to MD */
	}
	

	
	/**
	 * Generates ECC specific constants and configures Curve parameters a,b and prime field p
	 * @param a
	 * 			Curve 'a' parameter
	 * @param b
	 * 			Curve 'b' parameter
	 * @param p
	 * 			Curve prime field 'p'
	 * 
	 */
	public static void generateECconstants(BigInteger a,BigInteger b, BigInteger p){
		BigInteger M1 = new BigInteger("1");
		for(int i=0; i < Rns.h1 ; i++){
			M1 = M1.multiply(Rns.base1mod[i]);
		}
		
		Main.codeFile.println("-- INIT");
		Main.dataFile.println("-- INIT");
		
		Rns.generateMMConstantsFor(p);
		
//		MMmodN=new Rns(M1.multiply(M1).mod(ECC.N).toString(),"M^2modN");
//		
//		
//		one = new Rns("1","one");
		eight = new Rns("8","eight");
		four = new Rns("4","four");
		two = new Rns("2","two");
		
		N = p;
		a_bin_OD = a.mod(N);
		b_bin_OD = b.mod(N);
		a_OD = new Rns(a.mod(N).toString(),"a_OD");
		b_OD = new Rns(b.mod(N).toString(),"b_OD");
		a_MD = new Rns("a_MD");
		b_MD = new Rns("b_MD");
		a_OD.modularMult(Rns.MMmodN, a_MD); /* to MD */    //may be removed if using newPointMult
		b_OD.modularMult(Rns.MMmodN, b_MD); /* to MD */    
		
//		MmodN=new Rns(M1.mod(ECC.N).toString(),"MmodN"); /* const */
//		Hardware.printHexn(Rns.RNStoIntB2("regularMMC4"),Main.BITS_PER_MOD,Main.dataFile);
//		Hardware.printHexn(Rns.RNStoIntB2("regularMMC2"),Main.BITS_PER_MOD,Main.dataFile);
//		Hardware.printHexn(Rns.RNStoIntB1("regularMMC2"),Main.BITS_PER_MOD,Main.dataFile);
//		
//		Main.assemblyFile.println("-- "+"01" + " " + "Bin-to-RNS_p" + " " + "regularMMC4" + " " + "-----" + " "+ "-----");
//		Hardware.printHexInstruction("01","0100","1","regularMMC4",null,null, Main.codeFile);
//		Main.assemblyFile.println("-- "+"10" + " " + "Bin-to-RNS" + " " + "regularMMC4" + " " + "-----" + " "+ "-----");
//		Hardware.printHexInstruction("10","0100","0","regularMMC4",null,null, Main.codeFile);
//		
//		
//		Main.assemblyFile.println("-- "+"01" + " " + "Bin-to-RNS_p" + " " + "regularMMC2" + " " + "-----" + " "+ "-----");
//		Hardware.printHexInstruction("01","0100","1","regularMMC2",null,null, Main.codeFile);
//		Main.assemblyFile.println("-- "+"10" + " " + "Bin-to-RNS" + " " + "regularMMC2" + " " + "-----" + " "+ "-----");
//		Hardware.printHexInstruction("10","0100","0","regularMMC2",null,null, Main.codeFile);
//		
//		
//		Main.assemblyFile.println("-- "+"01" + " " + "Bin-to-RNS" + " " + "regularMMC2" + " " + "-----" + " "+ "-----");
//		Hardware.printHexInstruction("01","0100","0","regularMMC2",null,null, Main.codeFile);
		
		System.out.println("Number of registers after constant generation. Base1: "+Hardware.HWbase1mod[0].registerBank.size());
		System.out.println("Number of registers after constant generation. Base2: "+Hardware.HWbase2mod[0].registerBank.size());
//		System.out.println("Number of registers after constant generation. Modulus extra: "+Hardware.HWbaseExtra.registerBank.size());
		
	}
	
	
	
	/**
	 * ECC point scalar multiplication in RNS
	 * @param scalar
	 * 				 scalar to multiply
	 * @return binary EC point after multiplication
	 */
	public ECPoint_ pointMult(BigInteger scalar){
		Rns A=new Rns("A");
		Rns B=new Rns("B");
		Rns C=new Rns("C");
		Rns D=new Rns("D");
		Rns E=new Rns("E");
		Rns F=new Rns("F");
		Rns G=new Rns("G");
		Rns H=new Rns("H");
		Rns I=new Rns("I");
		Rns J=new Rns("J");
		Rns x1p=new Rns("x1p");
		Rns z1p=new Rns("z1p");
		Rns x2p=new Rns("x2p");
		Rns z2p=new Rns("z2p");
		Rns temp = new Rns("temp");
		Rns temp1 = new Rns("temp1");
		Rns temp2 = new Rns("temp2");
		
		
		x_MD.mult(Rns.one, x1p); //x1p = x_MD
		Rns.MmodN.mult(Rns.one,z1p); //z1p = MmodN
		
		/* mult 1 */
		x_MD.modularMult(x_MD,A);
		b_MD.modularMult(x_MD,B);
		
		/* add 1 */
		A.sub(a_MD,C);
		a_MD.mult(four, D);
		
		/* mult 2 */
		C.modularMult(C, C);
		A.modularMult(x_MD,A);
		D.modularMult(x_MD,D);
		/* add 2 */
		B.mult(eight,temp);
		C.sub(temp,x2p);
		A.add(b_MD,temp);
		temp.mult(four,temp);
		temp.add(D,z2p);
		
//		Rns.sync();
		
//		Main.codeFile.println("-- Loop");
		for(int i = (scalar.bitLength()-2) ; i>=0 ; i--){
			if(scalar.testBit(i)){
//				Main.codeFile.println("-- bit 1");
				/* mult 1 */
				x2p.modularMult(z1p, A);
				x1p.modularMult(z2p, B);
				x2p.modularMult(x1p, C);
				z2p.modularMult(z1p, D);
				x2p.modularMult(x2p, E);
				z2p.modularMult(z2p, F);
				b_MD.modularMult(z2p,H);
				F.modularMult(a_MD, I);
				D.modularMult(a_MD, J);
				
				/* add 1 */
				A.sub(B,z1p);
				A.add(B,x1p);
				C.sub(J,C);
				E.sub(I,A);
				
				
				
				/* mult 2 */
				D.modularMult(x1p,D);
				C.modularMult(C, x1p);
				z1p.modularMult(z1p, z1p);
				A.modularMult(A, A);
				F.modularMult(H, B);
				E.modularMult(x2p, E);
				x2p.modularMult(I, F);
				
				
				/* add 2 */
				E.add(B,temp);
				temp.add(F, G);
				
				
				/* mult 3 */
				b_MD.modularMult(D, D);
				x_MD.modularMult(z1p, z1p);
				x2p.modularMult(B, B);
				z2p.modularMult(G, F);
				
				/* add 3 */
				D.mult(four,temp);
				x1p.sub(temp, x1p);
				B.mult(eight,temp);
				A.sub(temp, x2p);
				F.mult(four,z2p);
				
//				Rns.sync();
			}else{
//				Main.codeFile.println("-- bit 0");
				/* mult 1 */
				x1p.modularMult(z2p, A);
				x2p.modularMult(z1p, B);
				x1p.modularMult(x2p, C);
				z1p.modularMult(z2p, D);
				x1p.modularMult(x1p, E);
				z1p.modularMult(z1p, F);
				b_MD.modularMult(z1p, H);
				F.modularMult(a_MD,  I);
				D.modularMult(a_MD,  J);
				
				/* add 1 */
				A.sub(B,z2p);
				A.add(B,x2p);
				C.sub(J,C);
				E.sub(I,A);
				
				
				
				/* mult 2 */
				D.modularMult(x2p,D);
				C.modularMult(C, x2p);
				z2p.modularMult(z2p, z2p);
				A.modularMult(A, A);
				F.modularMult(H, B);
				E.modularMult(x1p, E);
				x1p.modularMult(I, F);
				
				
				/* add 2 */
				E.add(B,temp);
				//a_OD.mult(F,temp1);
				temp.add(F, G);
				
				
				
				/* mult 3 */
				b_MD.modularMult(D, D);
				x_MD.modularMult(z2p, z2p);
				x1p.modularMult(B, B);
				z1p.modularMult(G, F);

				
				/* add 3 */
				D.mult(four,temp);
				x2p.sub(temp, x2p);
				B.mult(eight,temp);
				A.sub(temp, x1p);
				F.mult(four,z1p);
				
//				Rns.sync();
			}
		}
//		Main.codeFile.println("-- End Loop and Final Conversions");
		
		x1p.modularMult(Rns.one, A);
		z1p.modularMult(Rns.one, B);
		x2p.modularMult(Rns.one, C);
		z2p.modularMult(Rns.one, D);
		
		/*********************************************/
		System.out.println("x2p= "+C.toIntMRC_simul()+" z2p= "+D.toIntMRC_simul());
		System.out.println("x1p "+A.toIntMRC_simul()+" z1p "+B.toIntMRC_simul());
		return Mxy(A.toIntMRC(),B.toIntMRC(),C.toIntMRC(),D.toIntMRC());
		//return Mxy(A.toIntMRC(true),B.toIntMRC(true),BigInteger.ONE,BigInteger.ONE);
	}

	
	
	
	/**
	 * Point scalar conversion from projective coordinates to affine coordinates (performed in binary)
	 * 
	 * @param x1p
	 * 			 x projective coordinate  of point 1
	 * @param z1p   
	 * 			 y projective coordinate of point 1
	 * @param x2p   
	 * 			 x projective coordinate of point 2
	 * @param z2p   
	 * 			 y projective coordinate of point 2
	 * @return Point in affine coordinates
	 */
	ECPoint_ Mxy(BigInteger x1p, BigInteger z1p, BigInteger x2p, BigInteger z2p){
		BigInteger x3 = new BigInteger("0");
		BigInteger y3 = new BigInteger("0");
		BigInteger xPrime3;
		BigInteger aux1,aux2,aux3;
		BigInteger y1Times2;
		BigInteger inverse_y1Times2;




		/*implemented in software*/
				
		x3 = x1p.multiply(z1p.modInverse(N)).mod(N);
		xPrime3 = x2p.multiply(z2p.modInverse(N)).mod(N);
		aux1 = b_bin_OD.multiply(new BigInteger("2")).mod(N);
		aux2 = a_bin_OD.add(binPoint.x.multiply(x3)).multiply(binPoint.x.add(x3)).mod(N);

		aux3 = xPrime3.multiply((binPoint.x.subtract(x3)).pow(2)).mod(N);
		y1Times2 = binPoint.y.multiply(new BigInteger("2"));
		inverse_y1Times2 = y1Times2.modInverse(N);
		y3 = aux1.add(aux2).subtract(aux3).multiply(inverse_y1Times2).mod(N);

		
		return new ECPoint_(x3,y3,N,a_bin_OD,b_bin_OD);
	}
}
