package rns;

import java.io.FileNotFoundException;
import java.io.FileReader;
import java.util.Iterator;

import javax.xml.stream.XMLEventReader;
import javax.xml.stream.XMLInputFactory;
import javax.xml.stream.XMLStreamConstants;
import javax.xml.stream.XMLStreamException;
import javax.xml.stream.events.Attribute;
import javax.xml.stream.events.Characters;
import javax.xml.stream.events.EndElement;
import javax.xml.stream.events.StartElement;
import javax.xml.stream.events.XMLEvent;

public class XMLReader {
	XMLInputFactory factory = XMLInputFactory.newInstance();
	XMLEventReader eventReader; //= factory.createXMLEventReader( new FileReader(configurationFile) );
	XMLEvent event;// = eventReader.nextTag();
	StartElement startElement;
	EndElement endElement;
	String qName ;
	Characters characters ;
	Iterator<Attribute> attributes;
	
	XMLReader(String configurationFile){
		try {
			eventReader = factory.createXMLEventReader( new FileReader(configurationFile) );
			event = eventReader.nextTag();
			
			if(event.getEventType() == XMLStreamConstants.START_ELEMENT ){
				startElement = event.asStartElement();
				qName = startElement.getName().getLocalPart();
				if (!qName.equalsIgnoreCase("rns")){
					System.out.println("Wrong XML file, aborting.");
					System.exit(-1);
				}
			}else{
				System.out.println("Wrong XML file, aborting.");
				System.exit(-1);
			}
		} catch (FileNotFoundException | XMLStreamException e) {
			e.printStackTrace();
		}
	}
	
	
	boolean getStartElement(String string){
		try {
			event = eventReader.nextTag();

			if(event.getEventType()==XMLStreamConstants.START_ELEMENT){
				startElement = event.asStartElement();
				qName = startElement.getName().getLocalPart();
				if(qName.equals(string)){
					return true;
				}else{
					System.out.println("Something wrong near " + string + ", aborting.");
					System.exit(-1);
				}
			}
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		System.out.println("Something wrong near " + string + ", aborting.");
		System.exit(-1);
		return false;
	}
	void getEndElement(String string){
		try {
			event = eventReader.nextTag();

			if(event.getEventType()==XMLStreamConstants.END_ELEMENT){
				endElement = event.asEndElement();
				qName = endElement.getName().getLocalPart();
				if(qName.equals(string)){
					return;
				}else{
					System.out.println("Something wrong near " + string + ", aborting.");
					System.exit(-1);
				}
			}else{
				System.out.println("Something wrong near " + string + ", aborting.");
				System.exit(-1);
			}
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}
	
	
	String getCharacters(){
		try {
			event = eventReader.nextEvent();
	
			if(event.getEventType()==XMLStreamConstants.CHARACTERS){
				characters = event.asCharacters();
				return characters.getData();
			}else{
				System.out.println("Something wrong near, aborting.");
				System.exit(-1);
			}
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return null;
	}
	
	
	String getValueOf(String string){
		String result=null;
		
		if (getStartElement(string)){
			result = getCharacters();
			getEndElement(string);
		}
		return result;
		
//		try {
//			
//			event = eventReader.nextTag();
//			if(event.getEventType()==XMLStreamConstants.START_ELEMENT){
//				startElement = event.asStartElement();
//				qName = startElement.getName().getLocalPart();
//				if(qName.equals(string)){
//					event = eventReader.nextTag();
//					if(event.getEventType()==XMLStreamConstants.CHARACTERS){
//						characters = event.asCharacters();
//						result = characters.getData();
//						event = eventReader.nextTag();
//						if(event.getEventType()!=XMLStreamConstants.END_ELEMENT){
//							System.out.println("Something wrong near " + string + ", aborting.");
//							System.exit(-1);
//						}
//					}else{
//						System.out.println("Something wrong near " + string + ", aborting.");
//						System.exit(-1);
//					}
//				}else{
//					System.out.println("Something wrong near " + string + ", aborting.");
//					System.exit(-1);
//				}
//			}
//			
//		} catch (XMLStreamException e) {
//			e.printStackTrace();
//		}
//		return result;
	}
	
	String getAttributesOf(String string){
		String result = "";
		getStartElement(string);
		attributes = startElement.getAttributes();
		while (attributes.hasNext()){
			result = result + attributes.next().getValue()+" ";
		}
		return result;
	}
	
	boolean isEndElement(){
		try {
			event = eventReader.peek();
			while(event.getEventType()==XMLStreamConstants.CHARACTERS){
				event = eventReader.nextEvent();
				event = eventReader.peek();
			}
			

			if(event.getEventType()==XMLStreamConstants.END_ELEMENT){
					return true;
			}else{
				return false;
			}
		} catch (XMLStreamException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return false;
	}
	
	
}
