package examples;

import java.math.BigInteger;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import rns.ECC;
import rns.ECPointRNS;
import rns.Main;
import rns.Rns;

public class Example {

	/*----------------------- ATTENTION !! ------------------------
	|       This is just a copy of the source file located in      |
	|        \Eclipse Project and Source Code\rns\src\examples .   |
	|     Changes in this file will produce no results whatsoever. |
	|    If you wish to modify it or write your own, please use    |
	|              the class in the project directory              |
	--------------------------------------------------------------*/
	
	static void multExample(){
				
		/*******************************************************************************************************/
		/** Define hardware           											                              **/
		/*******************************************************************************************************/

		/* Define number of bits of the operands and the number of bits in the RNS architecture.
		 * Creates the ModuliSet and hardware structure. Prints hardware configuration to mult.xml.  */
		Main.createModuliSet(64, 16, "mult.xml");
		
		/*Alternatively, moduli set and hardware structure can be loaded from xml file*/
//		Main.loadModuliSet("mult.xml");
		
		/* Creates the output files, appending MULT to their names */
		Main.createFiles("MULT");
		/*******************************************************************************************************/
		
		
		
		/*******************************************************************************************************/
		/** Multiplication Example    											                              **/
		/*******************************************************************************************************/
		
		/* Operands to be set into the data memory, and loaded to the register*/
		Rns A = new Rns("70000","A");        //values are converted to RNS
		Rns B = new Rns("51000","B");        //values are converted to RNS
		
		BigInteger C_bin;	
		Rns C = new Rns("C"); /* reserve register for variable C without setting a value */
		
		
		/* C = A x B */
		A.mult(B, C);
		
		/* Convert back to binary*/
		C_bin = C.toIntMRC();
		
		/*******************************************************************************************************/
		
		
		/* Closes the output files */
		Main.closeFiles();
		
		/* Prints result to Console*/
		System.out.println(C_bin.toString());
	}

}
