package examples;

import java.math.BigInteger;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;

import rns.ECC;
import rns.ECPointRNS;
import rns.Main;
import rns.Rns;

public class Example {

	/*----------------------- ATTENTION !! ------------------------
	|       This is just a copy of the source file located in      |
	|        \Eclipse Project and Source Code\rns\src\examples .   |
	|     Changes in this file will produce no results whatsoever. |
	|    If you wish to modify it or write your own, please use    |
	|              the class in the project directory              |
	--------------------------------------------------------------*/

	static void Average(){
			
		
		/*******************************************************************************************************/
		/** Define hardware           											                              **/
		/*******************************************************************************************************/

		/* Define number of bits of the operands and the number of bits in the RNS architecture.
		 * Creates the ModuliSet and hardware structure. Prints hardware configuration to average.xml.  */
		Main.createModuliSet(256, 16, "average.xml");
		
		/*Alternatively, moduli set and hardware structure can be loaded from xml file*/
//		Main.loadModuliSet("average.xml");
		
		/* Creates the output files, appending MULT to their names */
		Main.createFiles("AVERAGE");
		/*******************************************************************************************************/	
		
		
		
		/*******************************************************************************************************/
		/** Average Example	- average of the 3 last inputs						                              **/
		/*******************************************************************************************************/
		
		/* Operands */
		Rns value1 = new Rns(BigInteger.ZERO.toString(),"value1");    //maximum 128 bits
		Rns value2 = new Rns("value2");                               //maximum 128 bits
		Rns value3 = new Rns("value3");                               //maximum 128 bits
		Rns constant = new Rns("33333333333333333333333333333333333333","constant"); // 1/3 * 10^38 (with 126 bits)
		Rns one = new Rns("1", "one");
		
		Rns intermediateResult = new Rns("intermediateResult");
		Rns result = new Rns("result");
		BigInteger result_bin;
		
		
		/* initialize all values to zero */
		value1.mult(one, value2);
		value2.mult(one, value3);
		
		/** for average of the last 3 inputs, loop would start here **/
		Main.codeFile.println("-- loop would start here");
		Main.dataFile.println("-- loop would start here");
		
		/* shift values */
		value2.mult(one, value3);
		value1.mult(one, value2);
		/* read new value */
		value1 = new Rns("45678","value1");
		
		/* add values */
		value1.add(value2, intermediateResult);
		intermediateResult.add(value3, intermediateResult);
		
		/* multiply by 1/3 x 10 ^ 38 */
		intermediateResult.mult(constant, result);
		
		/* Convert back to binary*/
		result_bin = result.toIntMRC();
		
		/*******************************************************************************************************/
		
		
		/* Closes the output files */
		Main.closeFiles();
		
		System.out.println(result_bin.doubleValue()*10e-38);
	}
	
}
